/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.estate.wrapper;

import cn.hutool.core.collection.CollUtil;
import org.springblade.common.constant.CommonConstant;
import org.springblade.community.entity.Agency;
import org.springblade.community.feign.IAgencyClient;
import org.springblade.core.mp.support.BaseEntityWrapper;
import org.springblade.core.tool.utils.BeanUtil;
import org.springblade.core.tool.utils.SpringUtil;
import org.springblade.estate.entity.ServerUser;
import org.springblade.estate.feign.IUserAccessPermissionsClient;
import org.springblade.estate.vo.ServerUserVO;
import org.springblade.system.expand.feign.IConfClient;

import java.util.List;
import java.util.Objects;

/**
 * 服务人员包装类,返回视图层所需的字段
 *
 * @author BladeX
 * @since 2022-01-04
 */
public class ServerUserWrapper extends BaseEntityWrapper<ServerUser, ServerUserVO>  {

	private static IConfClient confClient;
	private static IAgencyClient agencyClient;

	static {
		confClient = SpringUtil.getBean(IConfClient.class);
		agencyClient = SpringUtil.getBean(IAgencyClient.class);
	}

	public static ServerUserWrapper build() {
		return new ServerUserWrapper();
 	}

	@Override
	public ServerUserVO entityVO(ServerUser serverUser) {
		ServerUserVO serverUserVO = Objects.requireNonNull(BeanUtil.copy(serverUser, ServerUserVO.class));
		String faceUrl = confClient.addPrefix(serverUser.getFaceUrl());
		serverUserVO.setFaceUrl(faceUrl);
		Agency agency = agencyClient.getById(serverUser.getAgencyId());
		if(agency != null){
			serverUserVO.setAgencyName(agency.getName());
		}

		return serverUserVO;
	}

}
